//+------------------------------------------------------------------+
//|                                      Moving Average Zadvisor.mq4 |
//|                                             Copyright 2017, Me ! |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright   "2017 me!"
#property link        "http://www.mql4.com"
#property description "Moving Average ZadVisor"

#define MAGICMA  20131111
//--- Inputs
input double Lots          =0.1;
input double MaximumRisk   =0.02;
input double DecreaseFactor=3;
input int    MovingPeriodEMA  =100;
input int    MovingShiftEMA   =0;
input int    MovingPeriodDEMA  =25;
input int    MovingShiftDEMA  =0;
extern double    StopLoss         = 300;
extern double     TakeProfit           = 1000;
extern int        NumberOfTries        = 10;

extern string           TrailingStop_Setting = "---------- Trailing Stop Setting";
extern string           tsp4                 = " 4 = Breakeven + Lockin";
extern int              TrailingStopType     = 1;
extern int              TrailingStop         = 40;                     
extern string           ts4                  = "Settings for Type 4";
extern double           BreakEven            = 30;
extern int              LockInPips           = 1;        // Profit Lock in pips
extern bool             UseAutoMagic         = true;
extern bool             Show_Settings        = true;

double pipMultiplier = 1;
double pPoint;
int    digit;
int    MagicNumber;
extern int              ManualMagic          = 19283745;
bool   dummyResult;

string s_symbol;
string                  TicketComment        = "Zadvisor",
                        timefilterText       = "";

//bool RefreshRates();


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{

//----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   s_symbol = Symbol();
   pPoint   = MarketInfo(s_symbol,MODE_POINT);
   
   digit    = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
  
   
   if (UseAutoMagic) MagicNumber = GetMagic();
               else  MagicNumber = ManualMagic;    
   
	TicketComment  = StringConcatenate(TicketComment, "-", s_symbol, "-", Period());
	if(Show_Settings) subPrintDetails(); 
   if(Show_Settings==true) subPrintDetails();
   else Comment("");
   
   return(0);
}


//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//---
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//--- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//--- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//--- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
           {
            Print("Error in history!");
            break;
           }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL)
            continue;
         //---
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1)
         lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//--- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
  }
 
//+------------------------------------------------------------------+
//| Drawing Dots functions                                           |
//+------------------------------------------------------------------+
 void DrawDotRed()   {  
         string objName = "BullseyeRed" + Time[1]; 
         ObjectCreate(objName, OBJ_TEXT, 0, Time[1], Low[1]-200*Point); 
         ObjectSetText(objName, CharToStr(159), 14, "Wingdings", Red); 
      } 
 void DrawDotGreen()   
      {  
         string objName = "BullseyeGreen" + Time[1]; 
         ObjectCreate(objName, OBJ_TEXT, 0, Time[1], High[1]+200*Point); 
         ObjectSetText(objName, CharToStr(159), 14, "Wingdings", Lime); 
      } 
 void DrawDotBlue()   
      {  
         string objName = "BullseyeBlue" + Time[1]; 
         ObjectCreate(objName, OBJ_TEXT, 0, Time[1], High[1]+200*Point); 
         ObjectSetText(objName, CharToStr(159), 14, "Wingdings", Blue); 
      } 
  
  
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double ema;
   double dema;
   double ema1;
   double dema1;
   int res;
//--- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//--- get Moving Averages 
   ema1=iMA(NULL,0,MovingPeriodEMA,MovingShiftEMA,MODE_EMA,PRICE_CLOSE,1);
   ema=iMA(NULL,0,MovingPeriodEMA,MovingShiftEMA,MODE_EMA,PRICE_CLOSE,0);
   dema=iCustom(NULL,0,"DEMA",25,0,0);
   dema1=iCustom(NULL,0,"DEMA",25,0,1);
//--- sell conditions
   if( dema1 > ema1 && dema < ema)
     {
      DrawDotRed();
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,Bid+(StopLoss*Point),0,"",MAGICMA,0,Red);
     // if(ticket <= 0) Alert("OrderSend Error: ", GetLastError());
    //   else
     //    {
     //        bool res = OrderModify(ticket, 0, StopLoss, 0, 0);
     //        if(!res) {  Alert("OrderModify Error: ", GetLastError());
      //            Alert("IMPORTANT: ORDER #", ticket, " HAS NO STOPLOSS AND TAKEPROFIT");}
       //   }
         // return(ticket);
      
      
      return;
     }
//--- buy conditions
   if(dema1 < ema1 && dema > ema)
     {
     DrawDotGreen();
     res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-(StopLoss*Point),0,"",MAGICMA,0,Blue);
     //if(ticket <= 0) Alert("OrderSend Error: ", GetLastError());
    // else
    //     {
    //         bool ress = OrderModify(ticket, 0, StopLoss, 0, 0);
    //         if(!ress) {  Alert("OrderModify Error: ", GetLastError());
    //              Alert("IMPORTANT: ORDER #", ticket, " HAS NO STOPLOSS AND TAKEPROFIT");}
     //     }
     return;
     }
//---
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double ema;
   double dema;
//--- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//--- get Moving Averages 
   ema=iMA(NULL,0,MovingPeriodEMA,MovingShiftEMA,MODE_EMA,PRICE_CLOSE,0);
   dema=iCustom(NULL,0,"DEMA",25,0,0);
//---
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      
      //--- check order type 
      if(OrderType()==OP_BUY)
        {
         if(dema < ema)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,White))
               Print("OrderClose error ",GetLastError());
           }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(dema > ema)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,White))
               Print("OrderClose error ",GetLastError());
           }
         break;
        }
     }
//---
  }
  
//----------------------- TRAILING STOP FUNCTION
//----------------------- SOURCE   : CODERSGURU
//----------------------- MODIFIED : FIREDAVE
void subTrailingStop(int Type)
{
   RefreshRates();
   if(Type==OP_BUY)   // buy position is opened 
   DrawDotBlue();  
   {
      switch(TrailingStopType)
      {
//----------------------- AFTER PROFIT TRAILING STOP      
         case 1:
            if(Bid-NormalizeDouble(OrderOpenPrice(),digit)>pPoint*TrailingStop*pipMultiplier &&
              NormalizeDouble(OrderStopLoss(),digit)<Bid-pPoint*TrailingStop*pipMultiplier)
            {
               DrawDotBlue();
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Bid-pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Green);
               return;
            }
            break;
            
//----------------------- TRAILING STOP
         case 2:
            if(Bid>NormalizeDouble(OrderOpenPrice(),digit) &&
              NormalizeDouble(OrderStopLoss(),digit)<Bid-pPoint*TrailingStop*pipMultiplier)
            {
                DrawDotBlue();
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Bid-pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Green);
               return;
            }
            break;

         case 4:
            BreakEven_TrailingStop (Type);
            break;
//----------------------- DEFAULT : AFTER PROFIT TRAILING STOP      
         default:
            if(Bid-NormalizeDouble(OrderOpenPrice(),digit)>pPoint*TrailingStop*pipMultiplier &&
              NormalizeDouble(OrderStopLoss(),digit)<Bid-pPoint*TrailingStop*pipMultiplier)
            {
                DrawDotBlue();
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Bid-pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Green);
               return;
            }  
      }
   }

   if(Type==OP_SELL)   // sell position is opened   
   {
      switch(TrailingStopType)
      {
//----------------------- AFTER PROFIT TRAILING STOP      
         case 1:
            if(NormalizeDouble(OrderOpenPrice(),digit)-Ask>pPoint*TrailingStop*pipMultiplier)
            {
            if(NormalizeDouble(OrderStopLoss(),digit)>Ask+pPoint*TrailingStop*pipMultiplier || NormalizeDouble(OrderStopLoss(),digit)==0)
            {
                DrawDotBlue();
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Ask+pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Red);
               return;
            }
            }
            break;
            
//----------------------- TRAILING STOP
         case 2:
            if(NormalizeDouble(OrderOpenPrice(),digit)>Ask)
            {
            if(NormalizeDouble(OrderStopLoss(),digit)>Ask+pPoint*TrailingStop*pipMultiplier || NormalizeDouble(OrderStopLoss(),digit)==0)
            {
                DrawDotBlue();
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Ask+pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Red);
               return;
            }
            }
            break;

         case 4:
            BreakEven_TrailingStop (Type);
            break;
//----------------------- DEFAULT : AFTER PROFIT TRAILING STOP      
         default:
            if(NormalizeDouble(OrderOpenPrice(),digit)-Ask>pPoint*TrailingStop*pipMultiplier)
            {
            if(NormalizeDouble(OrderStopLoss(),digit)>Ask+pPoint*TrailingStop*pipMultiplier || NormalizeDouble(OrderStopLoss(),digit)==0)
            {
                DrawDotBlue();
               dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(Ask+pPoint*TrailingStop*pipMultiplier,digit),NormalizeDouble(OrderTakeProfit(),digit),0,Red);
               return;
            }
         }
      }
   }
}

void BreakEven_TrailingStop(int type)
{
   
   if (type==OP_BUY)
   {
     double pBid = MarketInfo(Symbol(), MODE_BID);
     if (pBid-NormalizeDouble(OrderOpenPrice(),digit) > pPoint*BreakEven * pipMultiplier ) 
     {
       double BuyStop = NormalizeDouble(OrderOpenPrice(),digit) + LockInPips * pPoint * pipMultiplier;
       if (digit > 0) BuyStop = NormalizeDouble(BuyStop,digit);
       if (NormalizeDouble(OrderStopLoss(),digit) < BuyStop)
          DrawDotBlue(); 
         dummyResult =OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),BuyStop,NormalizeDouble(OrderTakeProfit(),digit),LightGreen);
		 return;
	 }
  }
  if (type==OP_SELL)
  {
    double pAsk = MarketInfo(Symbol(), MODE_ASK);
    if (NormalizeDouble(OrderOpenPrice(),digit) - pAsk > pPoint*BreakEven  * pipMultiplier) 
    {
       double SellStop = NormalizeDouble(OrderOpenPrice(),digit) - LockInPips * pPoint * pipMultiplier;
       if (digit > 0) SellStop = NormalizeDouble(SellStop, digit);
       if (NormalizeDouble(OrderStopLoss(),digit) > SellStop) 
        DrawDotBlue();
          dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),SellStop,NormalizeDouble(OrderTakeProfit(),digit),DarkOrange);
		 return;
    }
  }   

}

void checkStlTpr(int ticket, double stoploss, double takeprofit)
{
   if (ticket<=0) return;
   
   //
   //
   //
   //
   //
   
   StopLoss   = 0;
   TakeProfit = 0;
   for(int i=0; i<NumberOfTries; i++)
   {
      RefreshRates();
      dummyResult = OrderSelect(ticket,SELECT_BY_TICKET);
         if(stoploss!=0 && OrderType()==OP_BUY)
               StopLoss = NormalizeDouble(OrderOpenPrice()-stoploss*pPoint*pipMultiplier,digit);
         else  StopLoss = NormalizeDouble(OrderOpenPrice()+stoploss*pPoint*pipMultiplier,digit);
         if (takeprofit!=0 && OrderType()==OP_BUY)
               TakeProfit = NormalizeDouble(OrderOpenPrice()+takeprofit*pPoint*pipMultiplier,digit);
         else  TakeProfit = NormalizeDouble(OrderOpenPrice()-takeprofit*pPoint*pipMultiplier,digit);
   
         //
         //
         //
         //
         //

         if (NormalizeDouble(OrderStopLoss(),digit)!=StopLoss || NormalizeDouble(OrderTakeProfit(),digit)!= TakeProfit)
         { 
            dummyResult = OrderModify(ticket,NormalizeDouble(OrderOpenPrice(),digit),StopLoss,TakeProfit,0,CLR_NONE);   
               int err=GetLastError(); checkErr("Modify order error ",err); if (err==0) break; 
               Sleep(5000);
                  continue;
         }
         break;
   }      
}

void checkErr(string what, int err)
{
     if (err!=0) 
     {
      //Print("Error - "+what+" (",err,") ", ErrorDescription(err));
      Print("Failed to execute order. Error is "+ GetLastError());
      }
}
//+------------------------------------------------------------------+
//| OnTick function                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false)
      return;
//--- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//---
  }
//+------------------------------------------------------------------+



//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE
//----------------------- MODIFIED : FIREDAVE
int GetMagic() 
{
   if (StringFind(s_symbol, "CADJPY") >= 0) return(4522221);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(4522222);
   
   if (StringFind(s_symbol, "XAUUSD") >= 0) return(4522231);
   if (StringFind(s_symbol, "XAGUSD") >= 0) return(4522232);
   if (StringFind(s_symbol, "BRENT")  >= 0) return(4522233);
   if (StringFind(s_symbol, "WTI")    >= 0) return(4522234);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(4522241);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(4522242);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(4522251);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(4522261);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(4522262);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(4522263);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(4522264);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(4522265);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(4522266);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(4522267);
   if (StringFind(s_symbol, "EURDKK") >= 0) return(4522268);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(4522271);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(4522272);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(4522273);
   if (StringFind(s_symbol, "GBPNZD") >= 0) return(4522274);
   if (StringFind(s_symbol, "GBPCAD") >= 0) return(4522275);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(4522281);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(4522282);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(4522283);
   if (StringFind(s_symbol, "USDDKK") >= 0) return(4522284);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(4522291);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(4522292);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(4522293);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(4522294);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(4522295);
   
return(ManualMagic);
}

//----------------------- PRINT COMMENT FUNCTION
//----------------------- SOURCE : CODERSGURU
void subPrintDetails()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment + timefilterText + NL;
   sComment = sComment + sp;
   sComment = sComment + "TakeProfit=" + DoubleToStr(TakeProfit,0) + " | ";
   sComment = sComment + "TrailingStop=" + DoubleToStr(TrailingStop,0) + " | ";
   sComment = sComment + "StopLoss=" + DoubleToStr(StopLoss,0) + NL; 
   sComment = sComment + sp;
  // sComment = sComment + "Reverse Entry Condition=" + subBoolToStr(ReverseCondition) + NL;
 //  sComment = sComment + "Confirmed On Entry=" + subBoolToStr(ConfirmedOnEntry) + NL;
 //  sComment = sComment + "Stop And Reverse=" + subBoolToStr(StopAndReverse) + NL;
 //  sComment = sComment + "Pure SAR=" + subBoolToStr(PureSAR) + NL;
   sComment = sComment + sp;
   sComment = sComment + "Lots=" + DoubleToStr(Lots,2) + " | ";
  // sComment = sComment + "MM=" + subBoolToStr(MM) + " | ";
 //  sComment = sComment + "Risk=" + DoubleToStr(Risk,0) + "%" + NL;
   sComment = sComment + sp;
  
   Comment(sComment);
}